Index: tests/Makefile
===================================================================
--- tests/Makefile	(revision 2c7df621d2337437a46b0ccee6a7801bc04db8f4)
+++ tests/Makefile	(revision 6a909671115ba5fac94c212c249264bf25ec8840)
@@ -11,5 +11,5 @@
 main_objs = account.o bitlbee.o conf.o crypting.o help.o ipc.o irc.o irc_commands.o log.o nick.o query.o root_commands.o set.o storage.o storage_xml.o storage_text.o user.o 
 
-test_objs = check.o check_util.o check_nick.o
+test_objs = check.o check_util.o check_nick.o check_md5.o
 
 check: $(test_objs) $(addprefix ../, $(main_objs)) ../protocols/protocols.o ../lib/lib.o
Index: tests/check.c
===================================================================
--- tests/check.c	(revision 2c7df621d2337437a46b0ccee6a7801bc04db8f4)
+++ tests/check.c	(revision 6a909671115ba5fac94c212c249264bf25ec8840)
@@ -4,6 +4,20 @@
 #include <check.h>
 #include "bitlbee.h"
+#include "testsuite.h"
 
 global_t global;	/* Against global namespace pollution */
+
+gboolean g_io_channel_pair(GIOChannel **ch1, GIOChannel **ch2)
+{
+	int sock[2];
+	if (socketpair(AF_UNIX, SOCK_STREAM, PF_UNIX, sock) < 0) {
+		perror("socketpair");
+		return FALSE;
+	}
+
+	*ch1 = g_io_channel_unix_new(sock[0]);
+	*ch2 = g_io_channel_unix_new(sock[1]);
+	return TRUE;
+}
 
 double gettime()
@@ -21,4 +35,7 @@
 Suite *nick_suite(void);
 
+/* From check_md5.c */
+Suite *md5_suite(void);
+
 int main (void)
 {
@@ -26,4 +43,5 @@
 	SRunner *sr = srunner_create(util_suite());
 	srunner_add_suite(sr, nick_suite());
+	srunner_add_suite(sr, md5_suite());
 	srunner_run_all (sr, CK_NORMAL);
 	nf = srunner_ntests_failed(sr);
Index: tests/check_md5.c
===================================================================
--- tests/check_md5.c	(revision 6a909671115ba5fac94c212c249264bf25ec8840)
+++ tests/check_md5.c	(revision 6a909671115ba5fac94c212c249264bf25ec8840)
@@ -0,0 +1,56 @@
+#include <stdlib.h>
+#include <glib.h>
+#include <gmodule.h>
+#include <check.h>
+#include <string.h>
+#include <stdio.h>
+#include "md5.h"
+
+/* From RFC 1321 */
+struct md5_test {
+	const char *str;
+	md5_byte_t expected[16];
+} tests[] = {
+	{ "", 
+		{ 0xd4, 0x1d, 0x8c, 0xd9, 0x8f, 0x00, 0xb2, 0x04, 0xe9, 0x80, 0x09, 0x98, 0xec, 0xf8, 0x42, 0x7e } },
+	{ "a",
+		{ 0x0c, 0xc1, 0x75, 0xb9, 0xc0, 0xf1, 0xb6, 0xa8, 0x31, 0xc3, 0x99, 0xe2, 0x69, 0x77, 0x26, 0x61 } },
+	{ "abc", 
+		{ 0x90, 0x01, 0x50, 0x98, 0x3c, 0xd2, 0x4f, 0xb0, 0xd6, 0x96, 0x3f, 0x7d, 0x28, 0xe1, 0x7f, 0x72 } },
+	{ "message digest", 
+		{ 0xf9, 0x6b, 0x69, 0x7d, 0x7c, 0xb7, 0x93, 0x8d, 0x52, 0x5a, 0x2f, 0x31, 0xaa, 0xf1, 0x61, 0xd0 } },
+	{ "abcdefghijklmnopqrstuvwxyz", 
+		{ 0xc3, 0xfc, 0xd3, 0xd7, 0x61, 0x92, 0xe4, 0x00, 0x7d, 0xfb, 0x49, 0x6c, 0xca, 0x67, 0xe1, 0x3b } },
+	{ "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",
+	    { 0xd1, 0x74, 0xab, 0x98, 0xd2, 0x77, 0xd9, 0xf5, 0xa5, 0x61, 0x1c, 0x2c, 0x9f, 0x41, 0x9d, 0x9f } },
+	{ "12345678901234567890123456789012345678901234567890123456789012345678901234567890", 
+		{ 0x57, 0xed, 0xf4, 0xa2, 0x2b, 0xe3, 0xc9, 0x55, 0xac, 0x49, 0xda, 0x2e, 0x21, 0x07, 0xb6, 0x7a } },
+
+	{ NULL },
+};
+
+static void check_sums(int l)
+{
+	int i;
+	for (i = 0; tests[i].str; i++) {
+		md5_byte_t sum[16];
+  		tcase_fn_start (tests[i].str, __FILE__, __LINE__);
+		md5_state_t state;
+		int di;
+
+		md5_init(&state);
+		md5_append(&state, (const md5_byte_t *)tests[i].str, strlen(tests[i].str));
+		md5_finish(&state, sum);
+
+		fail_if(memcmp(tests[i].expected, sum, 16) != 0, "%s failed", tests[i].str);
+	}
+}
+
+Suite *md5_suite (void)
+{
+	Suite *s = suite_create("MD5");
+	TCase *tc_core = tcase_create("Core");
+	suite_add_tcase (s, tc_core);
+	tcase_add_test (tc_core, check_sums);
+	return s;
+}
Index: tests/testsuite.h
===================================================================
--- tests/testsuite.h	(revision 6a909671115ba5fac94c212c249264bf25ec8840)
+++ tests/testsuite.h	(revision 6a909671115ba5fac94c212c249264bf25ec8840)
@@ -0,0 +1,6 @@
+#ifndef __BITLBEE_CHECK_H__
+#define __BITLBEE_CHECK_H__ 
+
+gboolean g_io_channel_pair(GIOChannel **ch1, GIOChannel **ch2);
+
+#endif /* __BITLBEE_CHECK_H__ */
